import React, {
  useState,
  useCallback,
  useEffect,
} from 'react';
import ReactDOM from 'react-dom';
import { csv, arc, pie } from 'd3';
import { message } from './message.js';

const csvUrl =
  'https://gist.githubusercontent.com/rajamrit-singh/4bfd3588f7c8ce510d30aa4ab2e5295f/raw/cssNamedColors.csv';
const width = 960;
const height = 500;
const centerX = width / 2;
const centerY = height / 2;
const pieArc = arc()
  .innerRadius(0)
  .outerRadius(width);

const App = () => {
  const [data, setData] = useState(null);

  useEffect(() => {
    d3.csv(csvUrl).then(setData);
  }, [csvUrl]);
  if (!data) {
    return <pre>Loading ... </pre>;
  }
  console.log(data[0]);
  return (
    <svg width={width} height={height}>
      <g transform={`translate(${centerX},${centerY})`}>
        {pie().value(1)(data).map((d) => (
          <path
            fill={d.data ['RGB hex value']}   
            d={pieArc(d)}
          />
        ))}
      </g>
    </svg>
  );
};

const rootElement = document.getElementById('root');
ReactDOM.render(<App />, rootElement);

        // {data.map((d, i) => (
        //   <path
        //     fill={d['RGB hex value']}
        //     d={pieArc({
        //       startAngle:
        //         (i / data.length) * (2 * Math.PI),
        //       endAngle:
        //         ((i + 1) / data.length) *
        //         (2 * Math.PI),
        //     })}
        //   ></path>
        // ))}